proc rtbis(&func,x1,x2,xacc);
  local left,jmax,fmid,func:proc,dx,i,xmid,b,f;
  jmax=300; /*maximum allowable bisections*/
  fmid=func(x2);
  f=func(x1);
  if f*fmid > 0;
    " fatal (rtbis) root must be bracketed for bisection ";
    retp( -15 );
  endif;
  if f < 0;
    left=x1;
    dx=x2-x1;
  else;
    left=x2;
    dx=x1-x2;
  endif;
  i=1;
  do while i le jmax;
    dx=dx*.5;
    xmid=left+dx;
    fmid=func(xmid);
    if fmid < 0;
      left=xmid;
    endif;
    if abs(fmid) < xacc;
      retp(xmid);
    endif;
    if abs(dx) < 1e-10;
      "(rtbis) Step size too small";
      retp(-10); /* return of -10 means step size too small */
    endif;
    i=i+1;
  endo;
  if abs(dx) < 1e-10;
    retp(-10);
  endif;
  if fmid == 0;
    retp(xmid);
  endif;
  "(rtbis) Iterations exceeded limit";
  retp(-5);  /* return of -5 means iteration limit exceeded */
endp;

proc vrtbis(&func,x1,x2,xacc);
  local left,jmax,fmid,func:proc,dx,i,xmid,b,f,index,n;
  n=rows(x1);
  if rows(x2) ne n;
    " fatal (rtbis) incomplete bracketing for bisection ";
    retp( -20*ones(n,1) );
  endif;
  jmax=300; /*maximum allowable bisections*/
  fmid=func(x2);
  f=func(x1);
  if maxc(f.*fmid) > 0;
    " fatal (rtbis) roots must be bracketed for bisection ";
    retp( -15*ones(n,1) );
  endif;
  left=x2;
  dx=x1-x2;
  index=indexcat(f.<0,1);
  if (ismiss(index)-1);
    left[index]=x1[index];
    dx[index]=x2[index]-x1[index];
  endif;
  i=1;
  do while i le jmax;
    dx=dx*.5;
    xmid=left+dx;
    fmid=func(xmid);
    index=indexcat(fmid.<0,1);
    if (ismiss(index)-1);
      left[index]=xmid[index];
    endif;
    if abs(fmid) < xacc;
      retp(xmid);
    endif;
    if minc(abs(dx)) < 1e-10;
      "(rtbis) Step size too small for at least one equation";
      retp(-10*ones(n,1)); /* return of -10 means step size too small */
    endif;
    i=i+1;
  endo;
  if minc(abs(dx)) < 1e-10;
    retp(-10*ones(n,1));
  endif;
  if fmid == 0;
    retp(xmid);
  endif;
  "(rtbis) Iterations exceeded limit";
  retp(-5*ones(n,1));  /* return of -5 means iteration limit exceeded */
endp;
