clear

cd "C:\Documents and Settings\g1jdf00\My Documents\Projects\citysize\data"
*import excel using simdata_lameq1069_001.xls, first
import excel using simdata_lameq1_001.xls, first


sort id year


xtset id year, yearly

sort id year
by id: gen dlyt = dlwt - dlqt + dlnt
sort year id
by year: egen aggdlwt = mean(dlwt)
by year: egen aggdlpt = mean(dlpt)
by year: egen aggdlqt = mean(dlqt)

sort id year
by id: gen dlwt_hat = dlwt - aggdlwt
by id: gen dlpt_hat = dlpt - aggdlpt
by id: gen dlqt_hat = dlqt - aggdlqt


cd "C:\Documents and Settings\g1jdf00\My Documents\Projects\citysize\stata"
*log using one-good-estimation.log, replace


scalar omega = 0
scalar alpha = .3
scalar phi = .97



 /* our data has 22 cities and 29 years */
sort id year
by id: gen da = (1-phi)*dlpt + (1-alpha)*phi*dlwt - dlqt
by id: gen dpq = dlpt - dlqt
by id: gen de = (1-alpha)*phi*dlzt
by id: gen dax = da-de

*twoway scatter dax dpq,  ytitle("da - epsilon") xtitle("dphat - dqhat") title("Lambda = 1.069")
*twoway scatter de da

/* SMALL SAMPLE*/
gmm  ({lambda}*da - ({lambda}-1)*dpq) if id<=22 & year>=471, ///   
  instruments(L1.dlwt L1.dlpt L1.dlqt) ///
  wmatrix(unadjusted) winitial(unadjusted) from(lambda 11) 
estat overid
matrix list e(b)
test [lambda]_cons - 1 = 0
  
ivregress 2sls da (dpq = L1.dlwt L1.dlpt L1.dlqt) if id<=22 & year>=471, noconstant first
reg da dpq if id<=22 & year>=471, noconstant 
nlcom 1/(1-_b[dpq])

/* LARGE SAMPLE */
gmm  ({lambda}*da - ({lambda}-1)*dpq), ///   
  instruments(L1.dlwt L1.dlpt L1.dlqt) ///
  wmatrix(unadjusted) winitial(unadjusted) from(lambda 11) 
estat overid
matrix list e(b)
test [lambda]_cons - 1 = 0
  
ivregress 2sls da (dpq = L1.dlwt L1.dlpt L1.dlqt) , noconstant first
reg da dpq, noconstant 
nlcom 1/(1-_b[dpq])

