clear

cd "C:\Documents and Settings\g1jdf00\My Documents\Projects\citysize\data"
import excel using zipf_plot_lameq1069_001.xls, first

sort id 
gen nrank_10731 = lnrank
gen nlevel_10731 = lnlevel
gen zrank_10731 = lnzrank
gen zlevel_10731 = lnzlevel
drop lnrank lnlevel lnzrank lnzlevel

save hold, replace

clear
*insheet using zipf_plot_Lameq1_001.csv
import excel using zipf_plot_lameq1_001.xls, first
sort id 
gen nrank_1 = lnrank
gen nlevel_1 = lnlevel
gen zrank_1 = lnzrank
gen zlevel_1 = lnzlevel
drop lnrank lnlevel lnzrank lnzlevel

sort id
merge 1:1 id using hold
drop _merge 


reg nrank_10731 nlevel_10731
reg nrank_1 nlevel_1




* Graphs
graph set print logo off
graph set eps logo off
set scheme s2color

twoway (scatter nrank_1 nlevel_1, msize(vsmall)) (scatter nrank_10731 	nlevel_10731, msize(vsmall))  ,  ///
  xtitle("Log Levels") ytitle("Log Rank") graphregion(color(white) style(none)) legend(off) ylabel(, nogrid) title("Population", color(black)) /// 
  text(3.75 .175 "With Agglomeration", placement(e)) text(2 .215 "Without Agglomeration", placement(w)) name(comp, replace)

  
twoway (scatter nrank_10731 nlevel_10731, msize(vsmall)) (scatter zrank_10731 zlevel_10731, msize(vsmall))  ,  ///
    xtitle("Log Levels") ytitle("Log Rank") graphregion(color(white) style(none)) legend(off) ylabel(, nogrid) name(lameq10731, replace) ///
	text(3.8 .175 "Population", placement(e)) text(2 .065 "Technology", placement(w)) 
	

graph export "C:\swp55\Docs\citysize\Econometrica R2\figures\zipf.eps", as(eps) preview(off) replace

graph combine lameq10731 comp, row(2) graphregion(color(white) style(none)) imargin(small) ycommon
  
  /* add labels in graph editor */
twoway (scatter lnrank lnlevel, msize(small)) (scatter lnzrank lnzlevel, msize(small)),  ///
  xtitle("Log Levels") ytitle("Log Rank") graphregion(color(white) style(none)) legend(off) ylabel(, nogrid)
